#pragma once

#include "util/basengramer.hpp"
#include "util/output.hpp"
#include "util/string.hpp"
#include <map>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

class STHashNgramer : public STBaseNgramer {
   std::unordered_map<OwnedString, std::map<OwnedString, uint32_t>> ngrams;
   std::unordered_set<BorrowedString> found;

   public:
   STHashNgramer() : ngrams() {}

   void query(const BorrowedString& document, QueryOut& out) override;
   void add(const BorrowedString& ngram) override;
   void remove(const BorrowedString& ngram) override;
};